#! /bin/bash
#
# Name: bootpause.sh
# Author: SpinetiX S.A.
# Copyright: 2015 SpinetiX
# License: 2015 (c) SpinetiX. This file is licensed
#          under the terms of the GNU General Public License version 2.
#          This program is licensed "as is" without any warranty of any
#          kind, whether express or implied.
#
# Copyright 1999-2003 MontaVista Software, Inc.
# Copyright 2002, 2003, 2004 Sony Corporation
# Copyright 2002, 2003, 2004 Matsushita Electric Industrial Co., Ltd.
#
### BEGIN INIT INFO
# Required-Start:
# Required-Stop:
# Should-Start:
# Should-Stop:
# Default-Start:
# Default-Stop:
# Short-Description: boot pause
# Description: pauses boot mainly for cross host synchronization
### END INIT INFO

# NOTE: this should run before any other boot scripts that may
# exchange information with other systems but after the config reset
# script. Normally it should be run right before network is brought
# up.

# Init script information
NAME=bootpause
DESC="boot pause"

# Load init script configuration
[ -f /etc/default/$NAME ] && . /etc/default/$NAME

case "$1" in

    start)
        if [ -n "$BOOTPAUSE" ]; then
            echo -n "Pausing boot for $BOOTPAUSE secs... "
            sleep "$BOOTPAUSE"
            echo " done"
        fi
        ;;

    stop)
        ;;
esac
